From 6fcb7e24d4d26cb97a300d89f9a26a8fbc6aea9b Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Thu, 12 Jun 2025 07:19:01 +0300
Subject: [PATCH 94/94] cities.rulesets: Replace tabs with spaces

See RM #1516

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/alien/cities.ruleset         | 16 ++++++++--------
 data/civ1/cities.ruleset          | 16 ++++++++--------
 data/civ2/cities.ruleset          | 16 ++++++++--------
 data/civ2civ3/cities.ruleset      | 16 ++++++++--------
 data/classic/cities.ruleset       | 16 ++++++++--------
 data/goldkeep/cities.ruleset      | 16 ++++++++--------
 data/granularity/cities.ruleset   |  4 ++--
 data/multiplayer/cities.ruleset   | 16 ++++++++--------
 data/sandbox/cities.ruleset       | 16 ++++++++--------
 data/stub/cities.ruleset          |  4 ++--
 data/webperimental/cities.ruleset | 16 ++++++++--------
 11 files changed, 76 insertions(+), 76 deletions(-)

diff --git a/data/alien/cities.ruleset b/data/alien/cities.ruleset
index 11e8bf4dc4..2d17a45cb8 100644
--- a/data/alien/cities.ruleset
+++ b/data/alien/cities.ruleset
@@ -62,11 +62,11 @@ Culturists create works that keep people satisfied. They create two luxury \
 points per turn, four if Specialist Training tech is known.")
 
 [specialist_scientist]
-name		= _("Scientists")
-short_name	= _("?Scientist:S")
+name            = _("Scientists")
+short_name      = _("?Scientist:S")
 graphic         = "specialist.scientists"
 graphic_alt     = "specialist.scientist"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -75,12 +75,12 @@ Scientist research two bulbs worth of science each turn, four bulbs \
 when Specialist Training tech is known.")
 
 [specialist_government_merchant]
-name		= _("Government Merchants")
+name            = _("Government Merchants")
 rule_name       = "Government_Merchants"
-short_name	= _("?Merchant:M")
+short_name      = _("?Merchant:M")
 graphic         = "specialist.government_merchants"
 graphic_alt     = "specialist.taxman"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -89,13 +89,13 @@ Government Merchants produce two gold for the government each turn, \
 four once Specialist Training tech is known.")
 
 [parameters]
-add_to_size_limit  = 8		; cities >= this cannot be added to.
+add_to_size_limit = 8           ; cities >= this cannot be added to.
 angry_citizens = TRUE           ; set to FALSE to disable angry citizens
 celebrate_size_limit = 3        ; cities >= can celebrate
 
 changable_tax = TRUE            ; set to FALSE to disallow changing of tax rates
 
-;forced_science = 0		; set these fields when changeable_tax is turned off
+;forced_science = 0             ; set these fields when changeable_tax is turned off
 ;forced_luxury = 100
 ;forced_gold = 0
 
diff --git a/data/civ1/cities.ruleset b/data/civ1/cities.ruleset
index f295380a84..95957c6313 100644
--- a/data/civ1/cities.ruleset
+++ b/data/civ1/cities.ruleset
@@ -49,9 +49,9 @@ name            = _("Entertainers")
 ; (The original specialist names in the classic ruleset and derivatives were
 ; not designed to be user-visible.)
 rule_name       = "elvis"
-short_name	= _("?Elvis:E")
+short_name      = _("?Elvis:E")
 graphic         = "specialist.entertainer"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -63,9 +63,9 @@ See the section on Happiness for the effects of luxury points.\
 [specialist_scientist]
 name            = _("Scientists")
 rule_name       = "scientist"
-short_name	= _("?Scientist:S")
+short_name      = _("?Scientist:S")
 graphic         = "specialist.scientist"
-reqs		=
+reqs            =
     { "type", "name", "range"
       "MinSize", "5", "City"
     }
@@ -77,9 +77,9 @@ per turn.\
 [specialist_taxman]
 name            = _("Taxmen")
 rule_name       = "taxman"
-short_name	= _("?Taxman:T")
+short_name      = _("?Taxman:T")
 graphic         = "specialist.taxman"
-reqs		=
+reqs            =
     { "type", "name", "range"
       "MinSize", "5", "City"
     }
@@ -89,13 +89,13 @@ per turn.\
 ")
 
 [parameters]
-add_to_size_limit  = 8		; cities >= this cannot be added to.
+add_to_size_limit = 8           ; cities >= this cannot be added to.
 angry_citizens = TRUE           ; set to FALSE to disable angry citizens
 celebrate_size_limit = 3        ; cities >= can celebrate
 
 changable_tax = TRUE            ; set to FALSE to disallow changing of tax rates
 
-;forced_science = 0		; set these fields when changeable_tax is turned off
+;forced_science = 0             ; set these fields when changeable_tax is turned off
 ;forced_luxury = 100
 ;forced_gold = 0
 
diff --git a/data/civ2/cities.ruleset b/data/civ2/cities.ruleset
index f295380a84..95957c6313 100644
--- a/data/civ2/cities.ruleset
+++ b/data/civ2/cities.ruleset
@@ -49,9 +49,9 @@ name            = _("Entertainers")
 ; (The original specialist names in the classic ruleset and derivatives were
 ; not designed to be user-visible.)
 rule_name       = "elvis"
-short_name	= _("?Elvis:E")
+short_name      = _("?Elvis:E")
 graphic         = "specialist.entertainer"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -63,9 +63,9 @@ See the section on Happiness for the effects of luxury points.\
 [specialist_scientist]
 name            = _("Scientists")
 rule_name       = "scientist"
-short_name	= _("?Scientist:S")
+short_name      = _("?Scientist:S")
 graphic         = "specialist.scientist"
-reqs		=
+reqs            =
     { "type", "name", "range"
       "MinSize", "5", "City"
     }
@@ -77,9 +77,9 @@ per turn.\
 [specialist_taxman]
 name            = _("Taxmen")
 rule_name       = "taxman"
-short_name	= _("?Taxman:T")
+short_name      = _("?Taxman:T")
 graphic         = "specialist.taxman"
-reqs		=
+reqs            =
     { "type", "name", "range"
       "MinSize", "5", "City"
     }
@@ -89,13 +89,13 @@ per turn.\
 ")
 
 [parameters]
-add_to_size_limit  = 8		; cities >= this cannot be added to.
+add_to_size_limit = 8           ; cities >= this cannot be added to.
 angry_citizens = TRUE           ; set to FALSE to disable angry citizens
 celebrate_size_limit = 3        ; cities >= can celebrate
 
 changable_tax = TRUE            ; set to FALSE to disallow changing of tax rates
 
-;forced_science = 0		; set these fields when changeable_tax is turned off
+;forced_science = 0             ; set these fields when changeable_tax is turned off
 ;forced_luxury = 100
 ;forced_gold = 0
 
diff --git a/data/civ2civ3/cities.ruleset b/data/civ2civ3/cities.ruleset
index 17134129b5..249b728b8a 100644
--- a/data/civ2civ3/cities.ruleset
+++ b/data/civ2civ3/cities.ruleset
@@ -49,9 +49,9 @@ name            = _("Entertainers")
 ; (The original specialist names in the classic ruleset and derivatives were
 ; not designed to be user-visible.)
 rule_name       = "elvis"
-short_name	= _("?Elvis:E")
+short_name      = _("?Elvis:E")
 graphic         = "specialist.entertainer"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -64,9 +64,9 @@ See the section on Happiness for the effects of luxury points.\
 [specialist_scientist]
 name            = _("Scientists")
 rule_name       = "scientist"
-short_name	= _("?Scientist:S")
+short_name      = _("?Scientist:S")
 graphic         = "specialist.scientist"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -79,9 +79,9 @@ Voyage.\
 [specialist_taxman]
 name            = _("Taxmen")
 rule_name       = "taxman"
-short_name	= _("?Taxman:T")
+short_name      = _("?Taxman:T")
 graphic         = "specialist.taxman"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -92,12 +92,12 @@ A.Smith's Trading Co.\
 ")
 
 [parameters]
-add_to_size_limit  = 8		; cities >= this cannot be added to.
+add_to_size_limit = 8           ; cities >= this cannot be added to.
 angry_citizens = TRUE           ; set to FALSE to disable angry citizens
 celebrate_size_limit = 3        ; cities >= can celebrate
 
 changable_tax = TRUE            ; set to FALSE to disallow changing of tax rates
-;forced_science = 0		; set these fields when changeable_tax is turned off
+;forced_science = 0             ; set these fields when changeable_tax is turned off
 ;forced_luxury = 100
 ;forced_gold = 0
 
diff --git a/data/classic/cities.ruleset b/data/classic/cities.ruleset
index fc0fc252c0..8efe378532 100644
--- a/data/classic/cities.ruleset
+++ b/data/classic/cities.ruleset
@@ -49,9 +49,9 @@ name            = _("Entertainers")
 ; (The original specialist names in the classic ruleset and derivatives were
 ; not designed to be user-visible.)
 rule_name       = "elvis"
-short_name	= _("?Elvis:E")
+short_name      = _("?Elvis:E")
 graphic         = "specialist.entertainer"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -63,9 +63,9 @@ See the section on Happiness for the effects of luxury points.\
 [specialist_scientist]
 name            = _("Scientists")
 rule_name       = "scientist"
-short_name	= _("?Scientist:S")
+short_name      = _("?Scientist:S")
 graphic         = "specialist.scientist"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -77,9 +77,9 @@ per turn.\
 [specialist_taxman]
 name            = _("Taxmen")
 rule_name       = "taxman"
-short_name	= _("?Taxman:T")
+short_name      = _("?Taxman:T")
 graphic         = "specialist.taxman"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -89,12 +89,12 @@ per turn.\
 ")
 
 [parameters]
-add_to_size_limit  = 8		; cities >= this cannot be added to.
+add_to_size_limit = 8           ; cities >= this cannot be added to.
 angry_citizens = TRUE           ; set to FALSE to disable angry citizens
 celebrate_size_limit = 3        ; cities >= can celebrate
 
 changable_tax = TRUE            ; set to FALSE to disallow changing of tax rates
-;forced_science = 0		; set these fields when changeable_tax is turned off
+;forced_science = 0             ; set these fields when changeable_tax is turned off
 ;forced_luxury = 100
 ;forced_gold = 0
 
diff --git a/data/goldkeep/cities.ruleset b/data/goldkeep/cities.ruleset
index cb82cace13..ee272203c7 100644
--- a/data/goldkeep/cities.ruleset
+++ b/data/goldkeep/cities.ruleset
@@ -51,9 +51,9 @@ name            = _("Entertainers")
 ; (The original specialist names in the classic ruleset and derivatives were
 ; not designed to be user-visible.)
 rule_name       = "elvis"
-short_name	= _("?Elvis:E")
+short_name      = _("?Elvis:E")
 graphic         = "specialist.entertainer"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -65,9 +65,9 @@ See the section on Happiness for the effects of luxury points.\
 [specialist_scientist]
 name            = _("Scientists")
 rule_name       = "scientist"
-short_name	= _("?Scientist:S")
+short_name      = _("?Scientist:S")
 graphic         = "specialist.scientist"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -79,9 +79,9 @@ per turn.\
 [specialist_taxman]
 name            = _("Taxmen")
 rule_name       = "taxman"
-short_name	= _("?Taxman:T")
+short_name      = _("?Taxman:T")
 graphic         = "specialist.taxman"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -91,12 +91,12 @@ per turn.\
 ")
 
 [parameters]
-add_to_size_limit  = 8		; cities >= this cannot be added to.
+add_to_size_limit = 8           ; cities >= this cannot be added to.
 angry_citizens = TRUE           ; set to FALSE to disable angry citizens
 celebrate_size_limit = 3        ; cities >= can celebrate
 
 changable_tax = TRUE            ; set to FALSE to disallow changing of tax rates
-;forced_science = 0		; set these fields when changeable_tax is turned off
+;forced_science = 0             ; set these fields when changeable_tax is turned off
 ;forced_luxury = 100
 ;forced_gold = 0
 
diff --git a/data/granularity/cities.ruleset b/data/granularity/cities.ruleset
index 55f14bd407..a8726e5586 100644
--- a/data/granularity/cities.ruleset
+++ b/data/granularity/cities.ruleset
@@ -64,13 +64,13 @@ reqs            =
     }
 
 [parameters]
-add_to_size_limit  = 8		; cities >= this cannot be added to.
+add_to_size_limit = 8           ; cities >= this cannot be added to.
 angry_citizens = TRUE           ; set to FALSE to disable angry citizens
 celebrate_size_limit = 3        ; cities >= can celebrate
 
 changable_tax = TRUE            ; set to FALSE to disallow changing of tax rates
 
-;forced_science = 0		; set these fields when changeable_tax is turned off
+;forced_science = 0             ; set these fields when changeable_tax is turned off
 ;forced_luxury = 100
 ;forced_gold = 0
 
diff --git a/data/multiplayer/cities.ruleset b/data/multiplayer/cities.ruleset
index 700270d94d..7984dfb9ad 100644
--- a/data/multiplayer/cities.ruleset
+++ b/data/multiplayer/cities.ruleset
@@ -48,9 +48,9 @@ name            = _("Entertainers")
 ; (The original specialist names in the classic ruleset and derivatives were
 ; not designed to be user-visible.)
 rule_name       = "elvis"
-short_name	= _("?Elvis:E")
+short_name      = _("?Elvis:E")
 graphic         = "specialist.entertainer"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -62,9 +62,9 @@ See the section on Happiness for the effects of luxury points.\
 [specialist_scientist]
 name            = _("Scientists")
 rule_name       = "scientist"
-short_name	= _("?Scientist:S")
+short_name      = _("?Scientist:S")
 graphic         = "specialist.scientist"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -76,9 +76,9 @@ per turn.\
 [specialist_taxman]
 name            = _("Taxmen")
 rule_name       = "taxman"
-short_name	= _("?Taxman:T")
+short_name      = _("?Taxman:T")
 graphic         = "specialist.taxman"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -88,12 +88,12 @@ per turn.\
 ")
 
 [parameters]
-add_to_size_limit  = 8		; cities >= this cannot be added to.
+add_to_size_limit = 8           ; cities >= this cannot be added to.
 angry_citizens = TRUE           ; set to FALSE to disable angry citizens
 celebrate_size_limit = 3        ; cities >= can celebrate
 
 changable_tax = TRUE            ; set to FALSE to disallow changing of tax rates
-;forced_science = 0		; set these fields when changeable_tax is turned off
+;forced_science = 0             ; set these fields when changeable_tax is turned off
 ;forced_luxury = 100
 ;forced_gold = 0
 
diff --git a/data/sandbox/cities.ruleset b/data/sandbox/cities.ruleset
index 5815d20c7d..3ebc4c8091 100644
--- a/data/sandbox/cities.ruleset
+++ b/data/sandbox/cities.ruleset
@@ -49,9 +49,9 @@ name            = _("Entertainers")
 ; (The original specialist names in the classic ruleset and derivatives were
 ; not designed to be user-visible.)
 rule_name       = "elvis"
-short_name	= _("?Elvis:E")
+short_name      = _("?Elvis:E")
 graphic         = "specialist.entertainer"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -64,9 +64,9 @@ See the section on Happiness for the effects of luxury points.\
 [specialist_scientist]
 name            = _("Scientists")
 rule_name       = "scientist"
-short_name	= _("?Scientist:S")
+short_name      = _("?Scientist:S")
 graphic         = "specialist.scientist"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -79,9 +79,9 @@ Voyage.\
 [specialist_taxman]
 name            = _("Taxmen")
 rule_name       = "taxman"
-short_name	= _("?Taxman:T")
+short_name      = _("?Taxman:T")
 graphic         = "specialist.taxman"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -92,12 +92,12 @@ A.Smith's Trading Co.\
 ")
 
 [parameters]
-add_to_size_limit  = 8		; cities >= this cannot be added to.
+add_to_size_limit = 8           ; cities >= this cannot be added to.
 angry_citizens = TRUE           ; set to FALSE to disable angry citizens
 celebrate_size_limit = 3        ; cities >= can celebrate
 
 changable_tax = TRUE            ; set to FALSE to disallow changing of tax rates
-;forced_science = 0		; set these fields when changeable_tax is turned off
+;forced_science = 0             ; set these fields when changeable_tax is turned off
 ;forced_luxury = 100
 ;forced_gold = 0
 
diff --git a/data/stub/cities.ruleset b/data/stub/cities.ruleset
index d7b860be91..8ce50365b9 100644
--- a/data/stub/cities.ruleset
+++ b/data/stub/cities.ruleset
@@ -48,13 +48,13 @@ reqs            =
     }
 
 [parameters]
-add_to_size_limit  = 8		; cities >= this cannot be added to.
+add_to_size_limit = 8           ; cities >= this cannot be added to.
 angry_citizens = TRUE           ; set to FALSE to disable angry citizens
 celebrate_size_limit = 3        ; cities >= can celebrate
 
 changable_tax = TRUE            ; set to FALSE to disallow changing of tax rates
 
-;forced_science = 0		; set these fields when changeable_tax is turned off
+;forced_science = 0             ; set these fields when changeable_tax is turned off
 ;forced_luxury = 100
 ;forced_gold = 0
 
diff --git a/data/webperimental/cities.ruleset b/data/webperimental/cities.ruleset
index 2656ed476c..657af0def0 100644
--- a/data/webperimental/cities.ruleset
+++ b/data/webperimental/cities.ruleset
@@ -49,9 +49,9 @@ name            = _("Entertainers")
 ; (The original specialist names in the classic ruleset and derivatives were
 ; not designed to be user-visible.)
 rule_name       = "elvis"
-short_name	= _("?Elvis:E")
+short_name      = _("?Elvis:E")
 graphic         = "specialist.entertainer"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -63,9 +63,9 @@ See the section on Happiness for the effects of luxury points.\
 [specialist_scientist]
 name            = _("Scientists")
 rule_name       = "scientist"
-short_name	= _("?Scientist:S")
+short_name      = _("?Scientist:S")
 graphic         = "specialist.scientist"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -77,9 +77,9 @@ per turn.\
 [specialist_taxman]
 name            = _("Taxmen")
 rule_name       = "taxman"
-short_name	= _("?Taxman:T")
+short_name      = _("?Taxman:T")
 graphic         = "specialist.taxman"
-reqs		=
+reqs            =
     { "type", "name", "range"
 ; Nothing
     }
@@ -89,12 +89,12 @@ per turn.\
 ")
 
 [parameters]
-add_to_size_limit  = 8		; cities >= this cannot be added to.
+add_to_size_limit = 8           ; cities >= this cannot be added to.
 angry_citizens = TRUE           ; set to FALSE to disable angry citizens
 celebrate_size_limit = 3        ; cities >= can celebrate
 
 changable_tax = TRUE            ; set to FALSE to disallow changing of tax rates
-;forced_science = 0		; set these fields when changeable_tax is turned off
+;forced_science = 0             ; set these fields when changeable_tax is turned off
 ;forced_luxury = 100
 ;forced_gold = 0
 
-- 
2.47.2